import argparse
import time
from pathlib import Path

import cv2
import torch
import torch.backends.cudnn as cudnn
from numpy import random

from models.experimental import attempt_load
from utils.datasets import LoadStreams, LoadImages
from utils.general import check_img_size, check_requirements, check_imshow, non_max_suppression, apply_classifier, \
    scale_coords, xyxy2xywh, strip_optimizer, set_logging, increment_path
from utils.plots import plot_one_box
from utils.torch_utils import select_device, load_classifier, time_synchronized, TracedModel
import os

class YoloV7Processor():
    def __init__(self, source, weights, imgsz, trace, target_dir):
        self.source = source
        self.weights = weights
        self.imgsz = imgsz
        self.no_trace = trace
        self.view_img = False
        self.device = "cpu"
        self.augment = False
        self.conf_thres = 0.25
        self.iou_thres = 0.01
        self.classes = None
        self.agnostic_nms = False
        self.target_dir = target_dir

    def get_scaled_point(self, iheight, iwidth, points):
        x1, y1, x2, y2 = points
        x1 = x1 / iwidth
        x2 = x2 / iwidth
        y1 = y1 / iheight
        y2 = y2 / iheight

        centerx = (x2 + x1) / 2
        centery = (y2 + y1) / 2

        widthi = y2 - y1
        heighti = x2 - x1
        return centerx, centery, widthi, heighti

    def detect(self, save_img=False):
        source, weights, view_img, imgsz, trace = self.source, self.weights, self.view_img, self.imgsz, not self.no_trace
        # save_img = not opt.nosave and not source.endswith('.txt')  # save inference images
        webcam = source.isnumeric() or source.endswith('.txt') or source.lower().startswith(
            ('rtsp://', 'rtmp://', 'http://', 'https://'))

        # Directories
        # save_dir = Path(increment_path(Path(opt.project) / opt.name, exist_ok=opt.exist_ok))  # increment run
        # (save_dir / 'labels' if save_txt else save_dir).mkdir(parents=True, exist_ok=True)  # make dir

        # Initialize
        set_logging()
        device = select_device(self.device)
        half = device.type != 'cpu'  # half precision only supported on CUDA

        # Load model
        model = attempt_load(weights, map_location=device)  # load FP32 model
        stride = int(model.stride.max())  # model stride
        imgsz = check_img_size(imgsz, s=stride)  # check img_size

        if trace:
            model = TracedModel(model, device, self.img_size)

        if half:
            model.half()  # to FP16

        # Second-stage classifier
        classify = False
        if classify:
            modelc = load_classifier(name='resnet101', n=2)  # initialize
            modelc.load_state_dict(torch.load('weights/resnet101.pt', map_location=device)['model']).to(device).eval()

        # Set Dataloader
        vid_path, vid_writer = None, None
        if webcam:
            view_img = check_imshow()
            cudnn.benchmark = True  # set True to speed up constant image size inference
            dataset = LoadStreams(source, img_size=imgsz, stride=stride)
        else:
            dataset = LoadImages(source, img_size=imgsz, stride=stride)

        # Get names and colors
        names = model.module.names if hasattr(model, 'module') else model.names
        colors = [[random.randint(0, 255) for _ in range(3)] for _ in names]

        # Run inference
        if device.type != 'cpu':
            model(torch.zeros(1, 3, imgsz, imgsz).to(device).type_as(next(model.parameters())))  # run once
        old_img_w = old_img_h = imgsz
        old_img_b = 1

        t0 = time.time()
        for path, img, im0s, vid_cap in dataset:
            title, ext = os.path.splitext(os.path.basename(path))
            if ext != ".jpg":
                continue
            img = torch.from_numpy(img).to(device)
            img = img.half() if half else img.float()  # uint8 to fp16/32
            img /= 255.0  # 0 - 255 to 0.0 - 1.0
            if img.ndimension() == 3:
                img = img.unsqueeze(0)

            # Warmup
            if device.type != 'cpu' and (old_img_b != img.shape[0] or old_img_h != img.shape[2] or old_img_w != img.shape[3]):
                old_img_b = img.shape[0]
                old_img_h = img.shape[2]
                old_img_w = img.shape[3]
                for i in range(3):
                    model(img, augment=self.augment)[0]

            # Inference
            t1 = time_synchronized()
            with torch.no_grad():   # Calculating gradients would cause a GPU memory leak
                pred = model(img, augment=self.augment)[0]

            t2 = time_synchronized()

            # Apply NMS
            pred = non_max_suppression(pred, self.conf_thres, self.iou_thres, classes=self.classes, agnostic=self.agnostic_nms)

            t3 = time_synchronized()

            # Apply Classifier
            if classify:
                pred = apply_classifier(pred, modelc, img, im0s)

            # Process detections
            for i, det in enumerate(pred):  # detections per image
                if webcam:  # batch_size >= 1
                    p, s, im0, frame = path[i], '%g: ' % i, im0s[i].copy(), dataset.count
                else:
                    p, s, im0, frame = path, '', im0s, getattr(dataset, 'frame', 0)

                p = Path(p)  # to Path
                # save_path = str(save_dir / p.name)  # img.jpg
                # txt_path = str(save_dir / 'labels' / p.stem) + ('' if dataset.mode == 'image' else f'_{frame}')  # img.txt
                gn = torch.tensor(im0.shape)[[1, 0, 1, 0]]  # normalization gain whwh
                if len(det):
                    # Rescale boxes from img_size to im0 size
                    det[:, :4] = scale_coords(img.shape[2:], det[:, :4], im0.shape).round()

                    # Print results
                    for c in det[:, -1].unique():
                        n = (det[:, -1] == c).sum()  # detections per class
                        s += f"{n} {names[int(c)]}{'s' * (n > 1)}, "  # add to string
                    cc = []
                    if not (os.path.exists(self.target_dir)):
                        os.mkdir(self.target_dir)
                    for *xyxy, conf, cls in reversed(det):
                        cc.append(float(conf))
                    if min(cc)>0.80:
                        target_dir = f'{self.target_dir}\\high'
                    elif min(cc)>0.30:
                        target_dir = f'{self.target_dir}\\mid'
                    else:
                        target_dir = f'{self.target_dir}\\low'
                    # Write results
                    for *xyxy, conf, cls in reversed(det):

                        # if save_txt:  # Write to file
                        #     xywh = (xyxy2xywh(torch.tensor(xyxy).view(1, 4)) / gn).view(-1).tolist()  # normalized xywh
                        #     line = (cls, *xywh, conf) if opt.save_conf else (cls, *xywh)  # label format
                        #     with open(txt_path + '.txt', 'a') as f:
                        #         f.write(('%g ' * len(line)).rstrip() % line + '\n')

                        # if save_img or view_img:  # Add bbox to image
                        label = f'{names[int(cls)]}'
                        x1, y1, x2, y2 = plot_one_box(xyxy, im0, label=label, color=colors[int(cls)], line_thickness=1)

                # Print time (inference + NMS)
                        print("predictionsssss:  ")
                        print(label)
                        im0 = cv2.resize(im0, (416, 416))
                        height, width, _ = im0.shape
                        # if conf>0.80:
                        #     binn = '80'
                        # elif conf>0.:
                        # target_dir = f'{self.target_dir}\\{bin}'

                        if not (os.path.exists(target_dir)):
                            os.mkdir(target_dir)
                        cv2.imwrite(os.path.join(target_dir, title + ".jpg"), im0)

                        with open(os.path.join(target_dir, title + ".txt"), 'a') as f:
                            # for each_pred in predict:
                            mrp_label = []
                            # img = cv2.rectangle(img, (each_pred["points"][0], each_pred["points"][1]),
                            #                     (each_pred["points"][2], each_pred["points"][3]), (255, 0, 0), 2)
                            cx, cy, w, h = self.get_scaled_point(height, width, [x1, y1, x2, y2])
                            if label == "mrp":
                                # f.write("3 {} {} {} {}\n".format(cx, cy, h, w))
                                mrp_label.append([cx, cy, w, h])

                            else:

                                f.write("0 {} {} {} {}\n".format(cx, cy, h, w))
                            for label in mrp_label:
                                f.write("1 {} {} {} {}\n".format(label[0], label[1], label[3], label[2]))

                            # print(c1)
                            # print(c2)
                print(f'{s}Done. ({(1E3 * (t2 - t1)):.1f}ms) Inference, ({(1E3 * (t3 - t2)):.1f}ms) NMS')

                # Stream results
                if view_img:
                    cv2.imshow(str(p), im0)
                    cv2.waitKey(1)  # 1 millisecond
                # Save results (image with detections)
        #         if save_img:
        #             if dataset.mode == 'image':
        #                 cv2.imwrite(save_path, im0)
        #                 print(f" The image with the result is saved in: {save_path}")
        #             else:  # 'video' or 'stream'
        #                 if vid_path != save_path:  # new video
        #                     vid_path = save_path
        #                     if isinstance(vid_writer, cv2.VideoWriter):
        #                         vid_writer.release()  # release previous video writer
        #                     if vid_cap:  # video
        #                         fps = vid_cap.get(cv2.CAP_PROP_FPS)
        #                         w = int(vid_cap.get(cv2.CAP_PROP_FRAME_WIDTH))
        #                         h = int(vid_cap.get(cv2.CAP_PROP_FRAME_HEIGHT))
        #                     else:  # stream
        #                         fps, w, h = 30, im0.shape[1], im0.shape[0]
        #                         save_path += '.mp4'
        #                     vid_writer = cv2.VideoWriter(save_path, cv2.VideoWriter_fourcc(*'mp4v'), fps, (w, h))
        #                 vid_writer.write(im0)
        #
        # if save_txt or save_img:
        #     s = f"\n{len(list(save_dir.glob('labels/*.txt')))} labels saved to {save_dir / 'labels'}" if save_txt else ''
        #     #print(f"Results saved to {save_dir}{s}")
        #
        # print(f'Done. ({time.time() - t0:.3f}s)')
        #
    #
    # if __name__ == '__main__':
    #     parser = argparse.ArgumentParser()
    #     parser.add_argument('--weights', nargs='+', type=str, default='yolov7.pt', help='model.pt path(s)')
    #     parser.add_argument('--source', type=str, default='inference/images', help='source')  # file/folder, 0 for webcam
    #     parser.add_argument('--img-size', type=int, default=640, help='inference size (pixels)')
    #     parser.add_argument('--conf-thres', type=float, default=0.25, help='object confidence threshold')
    #     parser.add_argument('--iou-thres', type=float, default=0.45, help='IOU threshold for NMS')
    #     parser.add_argument('--device', default='', help='cuda device, i.e. 0 or 0,1,2,3 or cpu')
    #     parser.add_argument('--view-img', action='store_true', help='display results', default=True)
    #     parser.add_argument('--save-txt', action='store_true', help='save results to *.txt')
    #     parser.add_argument('--save-conf', action='store_true', help='save confidences in --save-txt labels')
    #     parser.add_argument('--nosave', action='store_true', help='do not save images/videos')
    #     parser.add_argument('--classes', nargs='+', type=int, help='filter by class: --class 0, or --class 0 2 3')
    #     parser.add_argument('--agnostic-nms', action='store_true', help='class-agnostic NMS')
    #     parser.add_argument('--augment', action='store_true', help='augmented inference')
    #     parser.add_argument('--update', action='store_true', help='update all models')
    #     parser.add_argument('--project', default='runs/detect', help='save results to project/name')
    #     parser.add_argument('--name', default='exp', help='save results to project/name')
    #     parser.add_argument('--exist-ok', action='store_true', help='existing project/name ok, do not increment')
    #     parser.add_argument('--no-trace', action='store_true', help='don`t trace model')
    #     opt = parser.parse_args()
    #     print(opt)
    #     #check_requirements(exclude=('pycocotools', 'thop'))
    #
    #     with torch.no_grad():
    #         if opt.update:  # update all models (to fix SourceChangeWarning)
    #             for opt.weights in ['yolov7.pt']:
    #                 detect()
    #                 strip_optimizer(opt.weights)
    #         else:
    #             detect()
